'Option Explicit
Private Const API_TRUE = 1

'   
Private Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Private Const OFN_ALLOWMULTISELECT = &H204
Private Const OFN_EXPLORER = &H80000
Private Const OFN_FILEMUSTEXIST = &H1000
Private Const OFN_EXTENSIONDIFFERENT = &H400
Private Const OFN_LONGNAMES = &H200000
Private Const OFN_NOCHANGEDIR = &H8
Private Const OFN_NODEREFERENCELINKS = &H100000
Private Const OFN_OVERWRITEPROMPT = &H2
Private Const OFN_SHAREAWARE = &H4000
Private Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Private Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long


'   
Private Declare Function GlobalLock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function GlobalUnlock Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Sub CopyMemory Lib "kernel32" Alias "RtlMoveMemory" (hpvDest As Any, hpvSource As Any, ByVal cbCopy As Long)
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long

'     
Public Enum RunModeEnum
        RMEDefault = 0
        RMeopen = 1
        RMEPrint = 2
End Enum
Public Enum DiskSpaceModeEnum
        DSMEFreeSpace = 0
        DSMEFullSpace = 1
        DSMEAvailableSpace = 2
End Enum
Public Enum UnitModeEnum
        UMEByte = 0
        UMEKiloByte = 1
        UMEMegaByte = 2
End Enum
Public Enum RunResultEnum
        RRENotExecute = 0
        RRERunAndWaitSuccess = 1
        RRECantSynchronize = 2
End Enum
Public Enum OpenFileEnum
        OFEOpenForLoad = 1
        OFEOpenForSave = 2
End Enum

Public Function MyGetFileName(OpenMode As OpenFileEnum, _
                              DirStr As String, _
                              FileNameStr() As String, _
                              FilterMass() As String, _
                              Optional FileExt As String = "", _
                              Optional hwndOwnerArg As Long = 0 _
                              ) As Boolean
Dim pOpenfilename As OPENFILENAME
Dim n As Integer
Dim k As Integer
Dim X As Long
Dim St1 As String
Dim St2 As String
Dim St3 As String
pOpenfilename.lStructSize = Len(pOpenfilename)
pOpenfilename.hwndOwner = hwndOwnerArg
If OpenMode = OFEOpenForLoad Then
  pOpenfilename.lpstrTitle = " "
Else
  pOpenfilename.lpstrTitle = " "
End If
If UBound(FilterMass, 1) = 1 Then
  n = UBound(FilterMass, 2)
  If n >= 0 Then
    For k = 0 To n
      If Len(FilterMass(1, k)) > 1 Then
        If Len(FilterMass(0, k)) > 1 Then
          St1 = St1 & (FilterMass(0, k) + vbNullChar)
        Else
          St1 = St1 & (" " + vbNullChar)
        End If
        St1 = St1 & (FilterMass(1, k) + vbNullChar)
      End If
    Next
    St1 = St1 & vbNullChar & vbNullChar
  Else
    St1 = " " & vbNullChar & "*.*" & vbNullChar & vbNullChar
  End If
End If
If FileExt <> "" Then
pOpenfilename.lpstrDefExt = FileExt
End If

pOpenfilename.lpstrInitialDir = DirStr
pOpenfilename.lpstrFilter = St1
pOpenfilename.lpstrFile = LPBuff(31001)
pOpenfilename.nMaxFile = 31000
pOpenfilename.lpstrFileTitle = LPBuff(31001)
pOpenfilename.nMaxFileTitle = 31000
pOpenfilename.flags = OFN_SHAREAWARE Or OFN_LONGNAMES Or OFN_NODEREFERENCELINKS Or OFN_EXPLORER
If OpenMode = OFEOpenForLoad Then
  pOpenfilename.flags = pOpenfilename.flags Or OFN_ALLOWMULTISELECT
  X = GetOpenFileName(pOpenfilename)
Else
  pOpenfilename.flags = pOpenfilename.flags Or OFN_OVERWRITEPROMPT
  X = GetSaveFileName(pOpenfilename)
End If
If X = API_TRUE Then
  MyGetFileName = True
  St1 = LP2VB2(pOpenfilename.lpstrFile)
  DirStr = Left(St1, pOpenfilename.nFileOffset - 1)
  n = -1
  St2 = St1
  Do
    St3 = MyGetLpStr(St2)
    n = n + 1
  Loop Until St2 = ""
  If n >= 1 Then
    ReDim FileNameStr(n - 1)
    St2 = St1
    St3 = MyGetLpStr(St2)
    For k = 1 To n
      FileNameStr(k - 1) = MyGetLpStr(St2)
    Next
  Else
    ReDim FileNameStr(0)
    FileNameStr(0) = Right$(St1, Len(St1) - pOpenfilename.nFileOffset)
  End If
Else
  MyGetFileName = False
  DirStr = ""
  ReDim FileNameStr(0)
  FileNameStr(0) = ""
End If
Close #intfh2
End Function

Public Function MyGetDirStr(Str1 As String) As String
Dim i As Integer, i1 As Integer, k As Integer
Dim St1 As String

If Len(Str1) > 0 Then
  k = 1
  Do
    i = InStr(k, Str1, "\")
    If i <> 0 Then i1 = i: k = i + 1
  Loop While i <> 0
  If i1 <> 0 Then
    St1 = Left$(Str1, i1)
  Else
    i = InStr(1, Str1, ":")
    If i = 0 Then
      St1 = ""
    Else
      St1 = Left$(Str1, i1) & "\"
    End If
  End If
Else
  St1 = ""
End If

MyGetDirStr = St1
End Function

Public Function NormalizeDir(Str1 As String) As String
If Len(Str1) = 0 Then
  NormalizeDir = ""
  Exit Function
Else
  If Right$(Str1, 1) <> "\" Then
    NormalizeDir = Str1 & "\"
    Exit Function
  Else
    NormalizeDir = Str1
    Exit Function
  End If
End If
End Function

Private Function VB2LP(St1 As String) As String
VB2LP = Left$(St1, 254) & vbNullChar
End Function

Private Function LP2VB(St1) As String
LP2VB = Left$(St1, InStr(1, St1, vbNullChar) - 1)
End Function

Private Function LP2VB2(St1) As String
LP2VB2 = Left$(St1, InStr(1, St1, vbNullChar & vbNullChar) - 1)
End Function

Private Function LPBuff(n As Integer) As String
LPBuff = String(n, vbNullChar)
End Function

Private Sub VB2BYTE(St1 As String, Mass1() As Byte)
Dim i As Integer
Dim j As Long
j = UBound(Mass1) - 1
If j > Len(St1) - 1 Then j = Len(St1) - 1
For i = 0 To j Mod 32768
  Mass1(i) = Asc(Mid(St1, i + 1, 1))
Next
Mass1(i) = 0
End Sub

Private Function BYTE2VB(Mass1() As Byte) As String
Dim St1 As String
Dim i As Integer
St1 = ""
For i = 0 To UBound(Mass1) Mod 32768
  If Mass1(i) = 0 Then Exit For
  St1 = St1 & Chr(Mass1(i))
Next
BYTE2VB = St1
End Function

Private Sub MemoryError()
MsgBox "  ,   !", 16, " "
End Sub

Private Sub FreeMemory(handle1 As Long, handle2 As Long)
Dim X As Long
If handle1 <> 0 Then
  X = GlobalFree(handle1)
  If X <> 0 Then MemoryError
End If
If handle2 <> 0 Then
  X = GlobalFree(handle2)
  If X <> 0 Then MemoryError
End If
End Sub

Private Function MyGetLpStr(St1 As String) As String
Dim i As Variant
i = InStr(1, St1, vbNullChar)
If IsNull(i) Then
  MyGetLpStr = ""
  St1 = ""
  Exit Function
ElseIf i = 0 Then
  MyGetLpStr = St1
  St1 = ""
  Exit Function
Else
  MyGetLpStr = Left$(St1, i - 1)
  St1 = Right$(St1, Len(St1) - i)
  Exit Function
End If
End Function

